from PyQt5.QtCore import pyqtSignal, QThread
from PyQt5.QtWidgets import QMainWindow
from ui_base import *
import json
from wjx_base import *


class MyThread(QThread):
   signal_stop = pyqtSignal(int)
   signal_final = pyqtSignal(int)
   signal_result = pyqtSignal(str,int)
   def __init__(self, n, num,wjx):
      super(MyThread,self).__init__()
      self.n = n
      self.num = int(num)
      self.url = wjx
      self._flag = False

      #self.signal_run = pyqtSignal([int],[str])
      #self.signal_stop = pyqtSignal()
      #self.signal_finish = pyqtSignal([int], [str])

   def run(self):
      while True:
         PostNum = 0
         # 提交50次
         for i in range(self.num):
            if self._flag:
               self.signal_stop.emit(PostNum)
               return
            result = Auto_WjX(self.url)
            # 10表示成功，20表示失败
            self.signal_result.emit(result,i)
            if '10' in result:
               print('[ Response : %s ]  ===> 提交成功！！！！' % result)
               PostNum += 1
            else:
               print('[ Response : %s ]  ===> 提交失败！！！！' % result)
            time.sleep(3)  # 设置休眠时间，这里要设置足够长的休眠时间
         print('脚本运行结束，成功提交%s份调查报告' % PostNum)  # 总结提交成功的数量，并打印
         self.signal_final.emit(PostNum)
         break

   def terminate(self):
      self._flag =True

class MyMainForm(QMainWindow, Ui_MainWindow):
   def __init__(self, parent=None):
      super(MyMainForm, self).__init__(parent)
      self.setupUi(self)
      self.pushButton_run.clicked.connect(self.wjxStart)
      self.pushButton_stop.clicked.connect(self.wjxStop)
      self.pushButton_stop.setEnabled(False)
      self.loadFromFile()

   def wjxStart(self):
       self.textBrowser.clear()
       self.progressBar.reset()
       self.pushButton_stop.setEnabled(True)
       self.pushButton_run.setEnabled(False)
       self.lineEdit_wjx.setEnabled(False)
       self.lineEdit_num.setEnabled(False)
       self.saveSeting()
       self.progressBar.setMaximum(int(self.num))
       self.textBrowser.append("开始提交"+self.num+"份任务")
       self.mythread = MyThread("thread  wjx",self.num,self.url)

       self.mythread.signal_final.connect(self.showMsg)
       self.mythread.signal_result.connect(self.showMsg2)
       self.mythread.signal_stop.connect(self.showMsg3)
       self.mythread.start()

   def saveSeting(self):
      self.url = self.lineEdit_wjx.text()
      self.num = self.lineEdit_num.text()

      save_file = {
         "wjx": self.url,
         "times": self.num
      }

      b = json.dumps(save_file)
      f = open("Settings.json", 'w')
      f.write(b)
      f.close()

   def loadFromFile(self):
      f = open("Settings.json", encoding='utf-8')
      settingFile = json.load(f)
      self.url = settingFile['wjx']
      self.num = settingFile['times']
      f.close()

      self.lineEdit_wjx.setText(self.url)
      self.lineEdit_num.setText(self.num)

   def wjxStop(self):
      self.pushButton_stop.setEnabled(False)
      self.pushButton_run.setEnabled(True)
      self.lineEdit_wjx.setEnabled(True)
      self.lineEdit_num.setEnabled(True)
      self.mythread.terminate()

   def showMsg(self,result):
      self.textBrowser.append('脚本运行结束，成功提交%s份调查报告' % result)
      self.pushButton_run.setEnabled(True)
      self.pushButton_stop.setEnabled(False)
      self.lineEdit_wjx.setEnabled(True)
      self.lineEdit_num.setEnabled(True)

   def showMsg2(self,result,postNum):
      self.progressBar.setValue(postNum + 1)
      if '10' in result:
         self.textBrowser.append('[ Response : %s ]  ===> 提交成功！！！！'%result)
      else:
         self.textBrowser.append('[ Response : %s ]  ===> 提交失败！！！！' % result)

   def showMsg3(self, num):
      self.textBrowser.append('脚本停止运行，已成功提交%s份调查报告' % num)